//----------------------------------------------------------------------//
//									//
//	OS2 utility functions						//
//									//
//----------------------------------------------------------------------//

#ifndef	__OS22UTIL_H
#define	__OS22UTIL_H


//----------------------------------------------------------------------//
//									//
//----------------------------------------------------------------------//

extern P_F_2	router;
extern PSDSETUP	Setup;

//ULONG	CLI(VOID);
//VOID	STI(ULONG ulFlags);


//----------------------------------------------------------------------//
//									//
//----------------------------------------------------------------------//

// PCI access
BOOL	Os2UtPCIMech1Read(ULONG ulAddrDesc, PVOID pvVal);
BOOL	Os2UtPCIMech1Write(ULONG ulAddrDesc, PVOID pvVal);


// memory
void  *Os2UtMemAlloc(UINT32 cbSize, UINT32 *pulPhys);
void  *Os2UtMemAllocLow(UINT32 cbSize, UINT32 *pulPhys);
VOID	Os2UtMemFree(PVOID pvMem);
BOOL	Os2UtMemCheckAccess(PVOID pvMem, UINT32 cbMem, UINT32 ulFlag);


// misc
VOID	Os2UtDelayExecution(ULONG ulMicroseconds, BOOL fCanBlock);


// output function and printf - replacement
typedef VOID (*Os2UtOutputFunction)(UINT32 c);
VOID	Os2UtRedirectOutput(Os2UtOutputFunction Function);
VOID	Os2Ut_vprintf(PCHAR fmt, PVOID pv);

void _cdecl printf(char *fmt, ...);


// asyncronous execution
typedef void (* Os2UtRunFunc)(void *);
typedef struct _Os2UtRunQueue Os2UtRunQueue;
typedef VOID (* APIENTRY Os2UtRunHandler)(Os2UtRunQueue *pQueue);

typedef struct _Os2UtRunElem
{
  Os2UtRunFunc		pfnFunc;	// function pointer
  void			*pvParam;	// context
} Os2UtRunElem;

typedef struct _Os2UtRunQueue
{
  Os2UtRunHandler	pfnHandler;	// ASM stub expects this to be the first
  ULONG			HookHandle;	// from KernAllocContextHook()
  ULONG			ulHead;		//
  ULONG			ulTail;		//
  Os2UtRunElem		arList[32];	// max # of functions in queue
} Os2UtRunQueue;

BOOL	Os2UtRunInitQueue(Os2UtRunQueue *pQueue,
			  Os2UtRunHandler pfnHandler);
BOOL	Os2UtRunInsertTask(Os2UtRunQueue *pQueue,
			   Os2UtRunFunc pfnFunc, PVOID pvParam);
BOOL	Os2UtRunQueryTask(Os2UtRunQueue *pQueue,
			  Os2UtRunFunc *ppfnFunc, PVOID *ppvParam);
VOID	Os2UtRunFlushQueue(Os2UtRunQueue *pQueue);


// semaphore support
typedef struct _Os2UtSemaphore
{
  ULONG		ulMaxUnits;
  ULONG		ulCurrUnits;
  ULONG		ulOwnerThread;
  ULONG		NestCnt;
  SpinLock_t	Lock;

} Os2UtSemaphore;

VOID Os2UtSemaphoreCreate(Os2UtSemaphore *pSem, ULONG ulMax, ULONG ulCurr);
VOID Os2UtSemaphoreDelete(Os2UtSemaphore *pSem);
BOOL Os2UtSemaphoreSignal(Os2UtSemaphore *pSem, ULONG ulUnits);
BOOL Os2UtSemaphoreWait(Os2UtSemaphore *pSem, ULONG ulUnits, ULONG ulTimeout);

BOOL Os2UtSemaphoreRequestMutex(Os2UtSemaphore *pSem, ULONG ulTimeout);
BOOL Os2UtSemaphoreReleaseMutex(Os2UtSemaphore *pSem);

#define	Os2UtSemaphoreAcquireLock(s)	KernAcquireSpinLock(&((s)->Lock));
#define	Os2UtSemaphoreReleaseLock(s)	KernReleaseSpinLock(&((s)->Lock));

#define	OS2UTSEM_WAIT_FOREVER		((ULONG)-1)
#define	OS2UTSEM_NOT_OWNED 		((ULONG)-1)

#define       ACPI_INTERRUPT_TREADID   0x1961
#define       ACPI_EXECUTE_TREADID     0x2007

ULONG Os2UtQueryThreadID(VOID);
ULONG APIENTRY	OemHlpXFileOpen  ( PCHAR pchFileName );
ULONG APIENTRY	OemHlpXFileClose ( VOID );
ULONG APIENTRY	OemHlpXFileRead  ( PVOID pData, ULONG cbData );
void * APIENTRY	OemHlpXGetDOSVar ( ULONG Number, ULONG Member );
void APIENTRY        ParseFile ( char *Buffer, ULONG Size );
ACPI_STATUS APIENTRY SetupAllAPIC ( void ); 
void APIENTRY        RestoreDPLDS ( void );
void APIENTRY        SetDPLDS ( void );
ULONG APIENTRY       OemHlpXGetIODELAYCNT(void);


#endif


