/* $Id: 1$ */
/** @pth.h
  *
  *  IDT structure for ACPI
  *
  * netlabs.org confidential
  *
  * Copyright (c) 2006 netlabs.org
  *
  * Author: Pavel Shtemenko <pasha@paco.odessa.ua>
  *
  * All Rights Reserved
  *
  */
#ifndef _PTH_H_
#define _PTH_H_
#pragma pack(1)

/****************************************************************************
* Page Dir and Pagetable records
*****************************************************************************/
typedef union _PTE_INFO
{
	// Whole
	UINT32   Cell;
	// By field
	struct _PteField_
	      {
             unsigned 	P  : 1;        // Page in memory (1 - present)
             unsigned	RW : 1;        // Enable RW for Page (group of page) from R3 if US == 1
             unsigned       US : 1;        // Enable access from R3
	      unsigned       PWT : 1;       // Update phys mem ( if CR0.CD == 0 )
             unsigned       PCD : 1;        // Cache enable ( if CR0.CD == 0 )
		// ਧ ⮣,   ࠭/⠡ ࠭ ⢫  (⥭/).
		// ਧ ⠭ ஬  ࢮ 饭,  뢠
		// ணࠬ ⥬.
		unsigned	A : 1;
		// ਧ ⮣,   ࠭ ⢫﫠 . ਧ ⠭
		// ஬  ࢮ 饭,  뢠 ணࠬ ⥬.
		unsigned	D : 1;

		// । ࠧ ࠭ (0-4, 1-  ० 䨧᪮ 樨).
		// ᯮ ⮫쪮  ४ਨ ⠡ ࠭.
		unsigned	PS : 1;

		// ਧ 쭮 ࠭,    ᯮ㥬 ࠭.
		//   祭 PGE ॣ CR4.
		unsigned      G : 1;

		//  㯭  ணࠬ ᯮ짮
		unsigned	ProgAvail : 3;

		//   ࠭
		unsigned	Base : 20;

	} Record;
} PTE_INFO, *PPTE_INFO;



/****************************************************************************
* Page Dir and Pagetable
*****************************************************************************/
typedef union _PAGE_TABLE
{
	UINT8		Bytes[4096];    // As byte
	PTE_INFO	PteInfo[1024];  // As struct
       UINT32        Ddwords[1024];  // As dwords
} PAGE_TABLE, *PPAGE_TABLE;

#pragma pack()

#endif